#! /bin/bash

find_ubivol() {
    # ubiname -> ubi volume
    local ubiname=$1
    local vol=
    local volname=

    for node in /sys/class/ubi/ubi*_*; do
        volname=`cat $node/name`
        if [ "$volname" = "$ubiname" ]; then
            vol=${node##/*/}
            break
        fi
    done

    echo $vol
}

MNTPOINT=$1
AREA=$2

for kind in kernel kmod initramfs opt rootfs; do
    imagefile=$kind.img

    if [ -f "$MNTPOINT/$imagefile" ]; then
        echo "* image file for $kind found, erase UBI area."

        if [ "$kind" != "opt" ]; then
            ubiname="$kind.$AREA"
        else
            ubiname="$kind"
        fi

        ubivol=`find_ubivol $ubiname`

        if [ "$ubivol" != "" ]; then
            echo -n "  erasing /dev/$ubivol ($ubiname) ... "
            ubiupdatevol -t /dev/$ubivol &> /dev/null
            res=$?

            if [ "$res" = "0" ]; then
                echo "succeeded."
            else
                echo "failed."
            fi
        fi
    fi
done

$MNTPOINT/rewrite_param
